library simproktools;

import 'package:simprokmachine/simprokmachine.dart';

class ReducerMachine<Event, State> extends ChildMachine<Event, State> {
  State? _initial;
  final BiMapper<State?, Event, State> _reducer;

  ReducerMachine.createNullInitial(
    BiMapper<State?, Event, State> reducer,
  )   : _initial = null,
        _reducer = reducer;

  ReducerMachine.create({
    required State initial,
    required BiMapper<State, Event, State> reducer,
  })  : _initial = initial,
        _reducer = ((state, event) => reducer(state!, event));

  @override
  void render(Event input, Handler<State> callback) {
    _initial = _reducer(_initial, input);
    callback(_initial!);
  }
}
