library simproktools;

import 'package:simprokmachine/simprokmachine.dart';

class RenderMachine<Input, Output> extends ChildMachine<Input, Output> {
  final BiHandler<Input, Handler<Output>> renderer;

  RenderMachine._(this.renderer);

  static RenderMachine<Input, Output> create<O, Input, Output>({
    required O object,
    required TriHandler<O, Input, Handler<Output>> renderer,
  }) {
    return RenderMachine._(
        (input, callback) => renderer(object, input, callback));
  }

  @override
  void render(Input input, Handler<Output> callback) {
    renderer(input, callback);
  }
}